Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 160600 - Accessing automounted directories can cause a process to hang forever
Summary: Accessing automounted directories can cause a process to hang forever
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel
Version: 3.0
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jeff Moyer
QA Contact: Brock Organ
URL:
Whiteboard:
Depends On:
Blocks: RHEL3U8CanFix
TreeView+ depends on / blocked
 
Reported: 2005-06-15 23:54 UTC by Jeff Moyer
Modified: 2007-11-30 22:07 UTC (History)
4 users (show)

Fixed In Version: RHSA-2006-0437
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2006-07-20 13:24:35 UTC


Attachments (Terms of Use)
Fix a race in the tail end of an expire event, causing a process to hang forever. (deleted)
2005-06-15 23:54 UTC, Jeff Moyer
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2006:0437 normal SHIPPED_LIVE Important: Updated kernel packages for Red Hat Enterprise Linux 3 Update 8 2006-07-20 13:11:00 UTC

Description Jeff Moyer 2005-06-15 23:54:25 UTC
Description of problem:
Automount can cause a program to hang when accessing a directory that is being
expired.

Version-Release number of selected component (if applicable):
autofs-4.1.3-130
kernel-2.4.21-32

How reproducible:
No reproducer available.

Steps to Reproduce:
1.
2.
3.
  
Actual results:
If the race is triggered, the process performing the lookup will hang
indefinitely.  You will be able to interrupt it, though.

Expected results:


Additional info:
This issue was reported upstream, and is resolved with the attached patch.  The
race is pretty clear, once you understand the code path, and the fix looks
straight forward and correct.

Comment 1 Jeff Moyer 2005-06-15 23:54:25 UTC
Created attachment 115514 [details]
Fix a race in the tail end of an expire event, causing a process to hang forever.

Comment 2 Jeff Moyer 2005-06-15 23:55:05 UTC
Posting patch to internal mailing list for review.

Comment 3 Ernie Petrides 2006-02-16 00:49:42 UTC
A fix for this problem has just been committed to the RHEL3 U8
patch pool this evening (in kernel version 2.4.21-40.1.EL).


Comment 4 Ernie Petrides 2006-04-28 21:42:31 UTC
Adding a couple dozen bugs to CanFix list so I can complete the stupid advisory.

Comment 6 Jeff Moyer 2006-05-03 17:56:51 UTC
*** Bug 180343 has been marked as a duplicate of this bug. ***

Comment 7 Joshua Giles 2006-05-31 17:48:30 UTC
I do see "no reproducer available," however can you provide steps you used
to make it reproduce in your environment?

Comment 8 Jeff Moyer 2006-06-01 00:27:28 UTC
You could setup a simple map with a low timeout (say 5 seconds).  Then, have a
script constantly access the mount point at 5 second intervals.  Ensure that
mounts and unmounts are occurring.  If not, up the script interval to 6 seconds.
 The unmount/mount pair must occur quite close to each other.

Comment 10 Red Hat Bugzilla 2006-07-20 13:24:36 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0437.html



Note You need to log in before you can comment on or make changes to this bug.